apiVersion: v1
kind: Template
labels:
  app: etherpad
  template: etherpad-buildconfig-with-secret
metadata:
  annotations:
    description: EtherPad - BuildConfig with Secret
    iconClass: icon-nodejs
    openshift.io/display-name: EtherPad
    tags: etherpad
  name: etherpad-buildconfig-with-secret
objects:
- apiVersion: v1
  kind: Secret
  metadata:
    annotations:
      template.openshift.io/expose-username: "{.data['username']}"
    name: git-etherpad-${ETHERPAD_REPOSITORY_REF}
  stringData:
    username: "${GIT_DEPLOYMENT_TOKEN}"
- apiVersion: v1
  kind: BuildConfig
  metadata:
    annotations:
      description: Builds EtherPad images
    labels:
      name: etherpad-${ETHERPAD_REPOSITORY_REF}
    name: etherpad-${ETHERPAD_REPOSITORY_REF}
  spec:
    failedBuildsHistoryLimit: 1
    resources:
      limits:
        cpu: 400m
        memory: 3Gi
    source:
      contextDir: /
      git:
        uri: ${ETHERPAD_REPOSITORY_URL}
        ref: "${ETHERPAD_REPOSITORY_REF}"
      sourceSecret:
        name: git-etherpad-${ETHERPAD_REPOSITORY_REF}
      type: Git
    strategy:
      type: Source
      sourceStrategy:
        env:
        - name: NODE_ENV
          value: production
        - name: NPM_MIRROR
          value: "${NPM_MIRROR}"
        forcePull: false
        from:
          kind: ImageStreamTag
          name: ${NODE_IMAGESTREAM_TAG}
    output:
      to:
        kind: ImageStreamTag
        name: etherpad:${ETHERPAD_REPOSITORY_REF}
    postCommit:
      args:
      - -fr
      - /opt/app-root/lib/pm2/.config
      - /opt/app-root/lib/pm2/.node-gyp
      command:
      - rm
    triggers:
    - type: ImageChange
    - type: ConfigChange
parameters:
- name: GIT_DEPLOYMENT_TOKEN
  description: Git deployment token
  displayName: Git Deployment Token
  required: true
- name: ETHERPAD_REPOSITORY_REF
  description: Set this to a branch name, tag or other ref of your repository if you are not using the default branch
  displayName: Git Reference
  value: master
- name: ETHERPAD_REPOSITORY_URL
  description: The URL of the repository with your EtherPad Dockerfile
  displayName: Git Repository URL
  required: true
  value: https://gitlab.com/synacksynack/opsperator/s2i-etherpad.git
- name: NODE_IMAGESTREAM_TAG
  description: Set this to NodeJS ImageStream tag serving as base for EtherPad BuildConfig
  displayName: NodeJS ImageStream Tag
  required: true
  value: nodejs:master
- name: NPM_MIRROR
  description: The custom NPM mirror URL
  displayName: Custom NPM Mirror URL
  value: 'https://registry.npmjs.org'
